/*====================================+=====================================+
! File CFrame.h                       ! Copyright (C) 2018-2019 Remi PASCAL !
+-------------------------------------+-------------------------------------+
! This file is part of kimfo.                                               !
! It is free software: you can redistribute it and/or modify it under the   !
! terms of the GNU General Public License as published by the Free Software !
! Foundation, either version 3 of the License, or any later version.        !
! This application is distributed in the hope that it will be useful, but   !
! WITHOUT ANY WARRANTY; without even the implied warranty of                !
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General !
! Public License for more details.                                          !
! You should have received a copy of the GNU General Public License along   !
! with this application. If not, see <http://www.gnu.org/licenses/>.        !
+==========================================================================*/



/*-------------------------------------------------------------------------*/
#pragma once
/*-------------------------------------------------------------------------*/
#include <wx/frame.h>
#include <wx/splitter.h>
#include <wx/taskbar.h>
#include "CServerList.h"
#include "common/sc_base.h"
/*-------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------*/
enum e_id_control
{
   /*----------------------------------------------------------------------*/
   ID_DUMMY_FIRST = wxID_HIGHEST + 1,
   ID_MAKE_DONATION,
   ID_CHECK_VERSION_MANUAL,
   ID_TOGGLE_SHOW,
   ID_REFRESH_SERVER,
   ID_CHECK_AVAIL,
   ID_SEL_ALL,
   ID_UNSEL_ALL,
   ID_SEL_INV,
   ID_SEL_UNSEL_HIL,
   ID_FIRST_CONTACT,
   ID_TOGGLE_AUTO_REFRESH_AVAIL
   /*----------------------------------------------------------------------*/
} ;

/*-------------------------------------------------------------------------*/
enum e_download_id { DID_VERSION, DID_SERVER, DID_AVAIL, DID_NB } ;

/*-------------------------------------------------------------------------*/
class CTaskBarIcon : public wxTaskBarIcon
{
   /*----------------------------------------------------------------------*/
   public :
      /*-------------------------------------------------------------------*/
      CTaskBarIcon() ;
      //~CTaskBarIcon() ;

   /*----------------------------------------------------------------------*/
   public :
      /*-------------------------------------------------------------------*/
      virtual wxMenu *CreatePopupMenu() override ;

   /*----------------------------------------------------------------------*/
} ;

/*-------------------------------------------------------------------------*/
class CFrame : public wxFrame
{
   /*----------------------------------------------------------------------*/
   public :
      /*-------------------------------------------------------------------*/
      CFrame() ;
      ~CFrame() ;

   /*----------------------------------------------------------------------*/
   public :
      /*-------------------------------------------------------------------*/
      CTaskBarIcon *m_taskbar_icon = nullptr ;
      /*-------------------------------------------------------------------*/
      wxPanel          *m_panel       = nullptr ;
      wxBoxSizer       *m_bsz         = nullptr ;
      wxSplitterWindow *m_spl_hor     = nullptr ;
      CServerList      *m_server_list = nullptr ;
      wxTextCtrl       *m_txt_info    = nullptr ;
      /*-------------------------------------------------------------------*/
      wxLogTextCtrl *m_log = nullptr ;

   /*----------------------------------------------------------------------*/
   public :
      /*-------------------------------------------------------------------*/
      void OnToggleAutoRefreshAvailable( wxCommandEvent &event ) ;
      void OnPrefs( wxCommandEvent &event ) ;
      /*-------------------------------------------------------------------*/
      void log_error( const wxString &s ) ;
      void log_message( const wxString &s ) ;
      void log_message_ok( const wxString &s ) ;
      /*-------------------------------------------------------------------*/
      void init_menubar() ;
      void init_toolbar() ;
      void init() ;
      /*-------------------------------------------------------------------*/
      void gui_enable_refresh_server( bool boo_on ) ;
      void gui_enable_check_avail( bool boo_on ) ;
      void gui_init_auto_check_avail() ;
      /*-------------------------------------------------------------------*/
      void gui_init_toggle_show() ;
      void force_show( bool boo_show ) ;
      void alert_selected_server_avail() ;
      void check_version( int i_err_code, const wxString &s_data,
                          bool boo_check_manual
                        ) ;

   /*----------------------------------------------------------------------*/
} ;

/*-------------------------------------------------------------------------*/



/*==========================================================================+
!                           End of file CFrame.h                            !
+==========================================================================*/
